# defaults

!ifndef model
model	= s
!endif

# extensions

.extensions: .dis

# path variables

dtmp	= depend.rsp

# C options

bcbase	= q:\env\bc
bc	= $bcbase\bin
bc_inc	= $bcbase\inc
bc_lib	= $bcbase\lib
# bc402base	= q:\env\bc402
# bc402	= $bc402base\bin
# bc402_inc	= $bc402base\include
# bc402_lib	= $bc402base\lib
bc45base	= q:\env\bc45
bc45	= $bc45base\bin
trc_lib	= \o

link	= $bc45\tlink
!ifdef windows
debug	= $bc45\tdw
!else
debug	= $bc45\td
!endif
prof	= tprof
brc	= $bc45\brc
brcc	= $bc45\brcc

# C options
stdcopt	= -2 -H- -I$bc_inc -O -P -Z -h -c -d -k- -p -v -w -y -m$model
!ifdef windows
gencopt	= $stdcopt -WE
!else
gencopt	= $stdcopt
!endif

dcopt	= $gencopt $cplus
rcopt	= $gencopt $cplus
%copt	= $dcopt
ccall	= bcc $%copt -o$^@ $[@

# Assembler options
asm	= \w\a
tasm	= $bc\tasm3
%sopt	= /ml /m /t /i$asm $splus
scall	= $tasm $%sopt $[@,$^@
sxcall	= tasmx /kh10000 $%sopt $[@,$^@

# Linker options
libdir	= $bc_lib;$trc_lib

!ifndef startup
!ifdef windows
startup	= $bc_lib\c0w$model.obj
!else
startup	= $bc_lib\c0$model.obj
!endif
!endif

!ifeq model s
trc	= c
!endif

!ifeq model c
trc	= c
!endif

!ifndef trc
trc	= l
!endif

!ifdef floats
!ifdef windows
fplib	= mathw$model
!else
!ifdef emu
fplib	= math$model emu
!else
fplib	= math$model fp87
!endif
!endif
!endif

!ifndef lib
!ifdef windows
lib	= $fplib import cw$model c$model $speclib
!else
lib	= $fplib c$model tr$trc $speclib
!endif
!endif

stdlopt	= /x /c /L$libdir
!ifdef windows
genlopt	= $stdlopt /Twe
!else
genlopt	= $stdlopt
!endif
dlopt	= $genlopt /v
rlopt	= $genlopt
%lopt	= $dlopt

ltmp	= objlist.tmp

obj	= $normobj $specobj

# Debugger options

!ifdef windows
%dopt	= -sd$source $dplus
!else
%dopt	= /vg /vp $dplus
!endif
dcall	= $debug $%dopt $exe $args

# Profiler options

%popt	= /vg /vp $pplus
pcall	= $prof $%popt $exe $args

# Resource compiler
rescall	= $brcc $resopt $[@ $^@

# command rules

all: .symbolic $exe

clean: .symbolic
	for %i in ($normobj) do del %i
	del $exe

tidy_up: .symbolic
	del *.obj
	del $ltmp
	del $dtmp
	del *.map
	del *.~*
	del *.old

link: .symbolic $obj
	del $exe
	%make $exe

run: .symbolic $exe
	$exe $args

just_run: .symbolic
	$exe $args

debug: .symbolic $exe
	$dcall

profile: .symbolic $exe
	$prof $%popt $exe $args

release: .symbolic
	del $exe
	set copt = $rcopt
	set lopt = $rlopt
	%make $exe

compact: .symbolic
	lzexe $exe
	copy $[@ $exe
	del $[@

editres: .symbolic
	%make $from
	$bc45\workshop $from

map: .symbolic $obj $res
	%make linker
	$link $%lopt $lplus /s @$ltmp
!ifdef windows
	$brc $%bopt $res $exe
!endif

disassemble: .symbolic
	set copt = $rcopt
	%make $from
	wdisasm $disopt $from >$to

depend: .symbolic
	%create $dtmp
	%append $dtmp $deplus
	%append $dtmp -s$bc_inc
	for %i in ($depend) do %append $dtmp %i
	depend -o$make @$dtmp
	del $dtmp
	%create turboc.cfg
	%append turboc.cfg $gencopt

# common make rules

linker: .symbolic # updates the linker response file
	%write  $ltmp $startup $specobj +
	%append $ltmp $normobj
	%append $ltmp $exe
	%append $ltmp
	%append $ltmp $lib
!ifdef windows
	%append $ltmp $def
!endif

$exe: $obj $res
	%make linker
	$link $%lopt $lplus @$ltmp
!ifdef windows
	$brc $%bopt $res $exe
!endif

.c.obj:
	$ccall

.cpp.obj:
	$ccall

.asm.obj:
	$scall

# special build rules
