/********************************************************************/
/* ENTITY: DXF entity processors.                                   */
/********************************************************************/

#ifndef __ENTITY_INCLUDED__
#define __ENTITY_INCLUDED__

#include <viewport.h>
#include <dxfin.h>
#include <trc.h>

class CEntityList;

class CEntity
{
public:
	CEntity() {}
	virtual ~CEntity();

	virtual void Read(CDxfin &stream) = 0;
	virtual void DrawOn(CViewport &view) = 0;
	virtual void PrintOn(FILE *stream) = 0;
	virtual void Transform(CMatrix &matrix) = 0;

	static CEntity *Get(CDxfin &stream);
};

class CEntLine : public CEntity
{
public:
	CJoint line;

	CEntLine() {}

	virtual void Read(CDxfin &stream);
	virtual void DrawOn(CViewport &view);
	virtual void PrintOn(FILE *stream);
	virtual void Transform(CMatrix &matrix);

	static CEntity *New();
};

#endif/*__ENTITY_INCLUDED__*/