/********************************************************************/
/* SHXFONT: interface to AutoCAD SHX font files.                    */
/********************************************************************/

#ifndef __SHXFONT_INCLUDED__
#define __SHXFONT_INCLUDED__

#include <fp.h>
#include <viewport.h>

class CShx
{
protected:
	char     *file;
	char    **font;
	int       first;
	unsigned  count;

	int Peek(int offset);

public:
	int       factor;

	CShx(const char *name);
	virtual ~CShx();

	virtual BOOL IsValid();
	char *Chr(int ascii);
};

class CShxDraw : public CShx
{
protected:
	CViewport *view;
	void MoveRel(const FP2D &amount);

public:
	BOOL       penDown;
	BOOL       vertical;
	BOOL       over;
	BOOL       under;

	// maintenance
	CShxDraw(const char *name);
	virtual ~CShxDraw();

	// state setup
	void OnView(CViewport *_view) { view = _view; }
	void Pen(BOOL pen) { penDown = pen; }

	// inquiry
	CViewport *View() { return view; }
	BOOL Pen() { return penDown; }

	// text processing functions
	void Expand(int glyph);
	void Expand(const char *s);
};

#endif/*__SHXFONT_INCLUDED__*/